diff -urNp linux-2.6.32.24/drivers/ata/libata-eh.c linux-2.6.32.24/drivers/ata/libata-eh.c
--- linux-2.6.32.24/drivers/ata/libata-eh.c	2010-09-20 17:26:42.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/libata-eh.c	2010-09-20 17:27:14.000000000 -0400
@@ -3590,7 +3590,7 @@ void ata_do_eh(struct ata_port *ap, ata_
  */
 void ata_std_error_handler(struct ata_port *ap)
 {
-	struct ata_port_operations *ops = ap->ops;
+	const struct ata_port_operations *ops = ap->ops;
 	ata_reset_fn_t hardreset = ops->hardreset;
 
 	/* ignore built-in hardreset if SCR access is not available */
diff -urNp linux-2.6.32.24/drivers/ata/libata-pmp.c linux-2.6.32.24/drivers/ata/libata-pmp.c
--- linux-2.6.32.24/drivers/ata/libata-pmp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/libata-pmp.c	2010-09-04 15:54:51.000000000 -0400
@@ -841,7 +841,7 @@ static int sata_pmp_handle_link_fail(str
  */
 static int sata_pmp_eh_recover(struct ata_port *ap)
 {
-	struct ata_port_operations *ops = ap->ops;
+	const struct ata_port_operations *ops = ap->ops;
 	int pmp_tries, link_tries[SATA_PMP_MAX_PORTS];
 	struct ata_link *pmp_link = &ap->link;
 	struct ata_device *pmp_dev = pmp_link->device;
diff -urNp linux-2.6.32.24/drivers/ata/pata_acpi.c linux-2.6.32.24/drivers/ata/pata_acpi.c
--- linux-2.6.32.24/drivers/ata/pata_acpi.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_acpi.c	2010-09-04 15:54:51.000000000 -0400
@@ -215,7 +215,7 @@ static struct scsi_host_template pacpi_s
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations pacpi_ops = {
+static const struct ata_port_operations pacpi_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.qc_issue		= pacpi_qc_issue,
 	.cable_detect		= pacpi_cable_detect,
diff -urNp linux-2.6.32.24/drivers/ata/pata_ali.c linux-2.6.32.24/drivers/ata/pata_ali.c
--- linux-2.6.32.24/drivers/ata/pata_ali.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_ali.c	2010-09-04 15:54:51.000000000 -0400
@@ -365,7 +365,7 @@ static struct scsi_host_template ali_sht
  *	Port operations for PIO only ALi
  */
 
-static struct ata_port_operations ali_early_port_ops = {
+static const struct ata_port_operations ali_early_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	.set_piomode	= ali_set_piomode,
@@ -382,7 +382,7 @@ static const struct ata_port_operations 
  *	Port operations for DMA capable ALi without cable
  *	detect
  */
-static struct ata_port_operations ali_20_port_ops = {
+static const struct ata_port_operations ali_20_port_ops = {
 	.inherits	= &ali_dma_base_ops,
 	.cable_detect	= ata_cable_40wire,
 	.mode_filter	= ali_20_filter,
@@ -393,7 +393,7 @@ static struct ata_port_operations ali_20
 /*
  *	Port operations for DMA capable ALi with cable detect
  */
-static struct ata_port_operations ali_c2_port_ops = {
+static const struct ata_port_operations ali_c2_port_ops = {
 	.inherits	= &ali_dma_base_ops,
 	.check_atapi_dma = ali_check_atapi_dma,
 	.cable_detect	= ali_c2_cable_detect,
@@ -404,7 +404,7 @@ static struct ata_port_operations ali_c2
 /*
  *	Port operations for DMA capable ALi with cable detect
  */
-static struct ata_port_operations ali_c4_port_ops = {
+static const struct ata_port_operations ali_c4_port_ops = {
 	.inherits	= &ali_dma_base_ops,
 	.check_atapi_dma = ali_check_atapi_dma,
 	.cable_detect	= ali_c2_cable_detect,
@@ -414,7 +414,7 @@ static struct ata_port_operations ali_c4
 /*
  *	Port operations for DMA capable ALi with cable detect and LBA48
  */
-static struct ata_port_operations ali_c5_port_ops = {
+static const struct ata_port_operations ali_c5_port_ops = {
 	.inherits	= &ali_dma_base_ops,
 	.check_atapi_dma = ali_check_atapi_dma,
 	.dev_config	= ali_warn_atapi_dma,
diff -urNp linux-2.6.32.24/drivers/ata/pata_amd.c linux-2.6.32.24/drivers/ata/pata_amd.c
--- linux-2.6.32.24/drivers/ata/pata_amd.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_amd.c	2010-09-04 15:54:51.000000000 -0400
@@ -397,28 +397,28 @@ static const struct ata_port_operations 
 	.prereset	= amd_pre_reset,
 };
 
-static struct ata_port_operations amd33_port_ops = {
+static const struct ata_port_operations amd33_port_ops = {
 	.inherits	= &amd_base_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	.set_piomode	= amd33_set_piomode,
 	.set_dmamode	= amd33_set_dmamode,
 };
 
-static struct ata_port_operations amd66_port_ops = {
+static const struct ata_port_operations amd66_port_ops = {
 	.inherits	= &amd_base_port_ops,
 	.cable_detect	= ata_cable_unknown,
 	.set_piomode	= amd66_set_piomode,
 	.set_dmamode	= amd66_set_dmamode,
 };
 
-static struct ata_port_operations amd100_port_ops = {
+static const struct ata_port_operations amd100_port_ops = {
 	.inherits	= &amd_base_port_ops,
 	.cable_detect	= ata_cable_unknown,
 	.set_piomode	= amd100_set_piomode,
 	.set_dmamode	= amd100_set_dmamode,
 };
 
-static struct ata_port_operations amd133_port_ops = {
+static const struct ata_port_operations amd133_port_ops = {
 	.inherits	= &amd_base_port_ops,
 	.cable_detect	= amd_cable_detect,
 	.set_piomode	= amd133_set_piomode,
@@ -433,13 +433,13 @@ static const struct ata_port_operations 
 	.host_stop	= nv_host_stop,
 };
 
-static struct ata_port_operations nv100_port_ops = {
+static const struct ata_port_operations nv100_port_ops = {
 	.inherits	= &nv_base_port_ops,
 	.set_piomode	= nv100_set_piomode,
 	.set_dmamode	= nv100_set_dmamode,
 };
 
-static struct ata_port_operations nv133_port_ops = {
+static const struct ata_port_operations nv133_port_ops = {
 	.inherits	= &nv_base_port_ops,
 	.set_piomode	= nv133_set_piomode,
 	.set_dmamode	= nv133_set_dmamode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_artop.c linux-2.6.32.24/drivers/ata/pata_artop.c
--- linux-2.6.32.24/drivers/ata/pata_artop.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_artop.c	2010-09-04 15:54:51.000000000 -0400
@@ -311,7 +311,7 @@ static struct scsi_host_template artop_s
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations artop6210_ops = {
+static const struct ata_port_operations artop6210_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= ata_cable_40wire,
 	.set_piomode		= artop6210_set_piomode,
@@ -320,7 +320,7 @@ static struct ata_port_operations artop6
 	.qc_defer		= artop6210_qc_defer,
 };
 
-static struct ata_port_operations artop6260_ops = {
+static const struct ata_port_operations artop6260_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= artop6260_cable_detect,
 	.set_piomode		= artop6260_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_at32.c linux-2.6.32.24/drivers/ata/pata_at32.c
--- linux-2.6.32.24/drivers/ata/pata_at32.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_at32.c	2010-09-04 15:54:51.000000000 -0400
@@ -172,7 +172,7 @@ static struct scsi_host_template at32_sh
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations at32_port_ops = {
+static const struct ata_port_operations at32_port_ops = {
 	.inherits		= &ata_sff_port_ops,
 	.cable_detect		= ata_cable_40wire,
 	.set_piomode		= pata_at32_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_at91.c linux-2.6.32.24/drivers/ata/pata_at91.c
--- linux-2.6.32.24/drivers/ata/pata_at91.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_at91.c	2010-09-04 15:54:51.000000000 -0400
@@ -195,7 +195,7 @@ static struct scsi_host_template pata_at
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations pata_at91_port_ops = {
+static const struct ata_port_operations pata_at91_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 
 	.sff_data_xfer	= pata_at91_data_xfer_noirq,
diff -urNp linux-2.6.32.24/drivers/ata/pata_atiixp.c linux-2.6.32.24/drivers/ata/pata_atiixp.c
--- linux-2.6.32.24/drivers/ata/pata_atiixp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_atiixp.c	2010-09-04 15:54:51.000000000 -0400
@@ -205,7 +205,7 @@ static struct scsi_host_template atiixp_
 	.sg_tablesize		= LIBATA_DUMB_MAX_PRD,
 };
 
-static struct ata_port_operations atiixp_port_ops = {
+static const struct ata_port_operations atiixp_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.qc_prep 	= ata_sff_dumb_qc_prep,
diff -urNp linux-2.6.32.24/drivers/ata/pata_atp867x.c linux-2.6.32.24/drivers/ata/pata_atp867x.c
--- linux-2.6.32.24/drivers/ata/pata_atp867x.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_atp867x.c	2010-09-04 15:54:51.000000000 -0400
@@ -274,7 +274,7 @@ static struct scsi_host_template atp867x
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations atp867x_ops = {
+static const struct ata_port_operations atp867x_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= atp867x_cable_detect,
 	.set_piomode		= atp867x_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_bf54x.c linux-2.6.32.24/drivers/ata/pata_bf54x.c
--- linux-2.6.32.24/drivers/ata/pata_bf54x.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_bf54x.c	2010-09-04 15:54:51.000000000 -0400
@@ -1464,7 +1464,7 @@ static struct scsi_host_template bfin_sh
 	.dma_boundary		= ATA_DMA_BOUNDARY,
 };
 
-static struct ata_port_operations bfin_pata_ops = {
+static const struct ata_port_operations bfin_pata_ops = {
 	.inherits		= &ata_sff_port_ops,
 
 	.set_piomode		= bfin_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_cmd640.c linux-2.6.32.24/drivers/ata/pata_cmd640.c
--- linux-2.6.32.24/drivers/ata/pata_cmd640.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_cmd640.c	2010-09-04 15:54:51.000000000 -0400
@@ -168,7 +168,7 @@ static struct scsi_host_template cmd640_
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations cmd640_port_ops = {
+static const struct ata_port_operations cmd640_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	/* In theory xfer_noirq is not needed once we kill the prefetcher */
 	.sff_data_xfer	= ata_sff_data_xfer_noirq,
diff -urNp linux-2.6.32.24/drivers/ata/pata_cmd64x.c linux-2.6.32.24/drivers/ata/pata_cmd64x.c
--- linux-2.6.32.24/drivers/ata/pata_cmd64x.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_cmd64x.c	2010-09-04 15:54:51.000000000 -0400
@@ -275,18 +275,18 @@ static const struct ata_port_operations 
 	.set_dmamode	= cmd64x_set_dmamode,
 };
 
-static struct ata_port_operations cmd64x_port_ops = {
+static const struct ata_port_operations cmd64x_port_ops = {
 	.inherits	= &cmd64x_base_ops,
 	.cable_detect	= ata_cable_40wire,
 };
 
-static struct ata_port_operations cmd646r1_port_ops = {
+static const struct ata_port_operations cmd646r1_port_ops = {
 	.inherits	= &cmd64x_base_ops,
 	.bmdma_stop	= cmd646r1_bmdma_stop,
 	.cable_detect	= ata_cable_40wire,
 };
 
-static struct ata_port_operations cmd648_port_ops = {
+static const struct ata_port_operations cmd648_port_ops = {
 	.inherits	= &cmd64x_base_ops,
 	.bmdma_stop	= cmd648_bmdma_stop,
 	.cable_detect	= cmd648_cable_detect,
diff -urNp linux-2.6.32.24/drivers/ata/pata_cs5520.c linux-2.6.32.24/drivers/ata/pata_cs5520.c
--- linux-2.6.32.24/drivers/ata/pata_cs5520.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_cs5520.c	2010-09-04 15:54:51.000000000 -0400
@@ -144,7 +144,7 @@ static struct scsi_host_template cs5520_
 	.sg_tablesize		= LIBATA_DUMB_MAX_PRD,
 };
 
-static struct ata_port_operations cs5520_port_ops = {
+static const struct ata_port_operations cs5520_port_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.qc_prep		= ata_sff_dumb_qc_prep,
 	.cable_detect		= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pata_cs5530.c linux-2.6.32.24/drivers/ata/pata_cs5530.c
--- linux-2.6.32.24/drivers/ata/pata_cs5530.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_cs5530.c	2010-09-04 15:54:51.000000000 -0400
@@ -164,7 +164,7 @@ static struct scsi_host_template cs5530_
 	.sg_tablesize	= LIBATA_DUMB_MAX_PRD,
 };
 
-static struct ata_port_operations cs5530_port_ops = {
+static const struct ata_port_operations cs5530_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.qc_prep 	= ata_sff_dumb_qc_prep,
diff -urNp linux-2.6.32.24/drivers/ata/pata_cs5535.c linux-2.6.32.24/drivers/ata/pata_cs5535.c
--- linux-2.6.32.24/drivers/ata/pata_cs5535.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_cs5535.c	2010-09-04 15:54:51.000000000 -0400
@@ -160,7 +160,7 @@ static struct scsi_host_template cs5535_
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations cs5535_port_ops = {
+static const struct ata_port_operations cs5535_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= cs5535_cable_detect,
 	.set_piomode	= cs5535_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_cs5536.c linux-2.6.32.24/drivers/ata/pata_cs5536.c
--- linux-2.6.32.24/drivers/ata/pata_cs5536.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_cs5536.c	2010-09-04 15:54:51.000000000 -0400
@@ -223,7 +223,7 @@ static struct scsi_host_template cs5536_
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations cs5536_port_ops = {
+static const struct ata_port_operations cs5536_port_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= cs5536_cable_detect,
 	.set_piomode		= cs5536_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_cypress.c linux-2.6.32.24/drivers/ata/pata_cypress.c
--- linux-2.6.32.24/drivers/ata/pata_cypress.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_cypress.c	2010-09-04 15:54:51.000000000 -0400
@@ -113,7 +113,7 @@ static struct scsi_host_template cy82c69
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations cy82c693_port_ops = {
+static const struct ata_port_operations cy82c693_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	.set_piomode	= cy82c693_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_efar.c linux-2.6.32.24/drivers/ata/pata_efar.c
--- linux-2.6.32.24/drivers/ata/pata_efar.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_efar.c	2010-09-04 15:54:51.000000000 -0400
@@ -222,7 +222,7 @@ static struct scsi_host_template efar_sh
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations efar_ops = {
+static const struct ata_port_operations efar_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= efar_cable_detect,
 	.set_piomode		= efar_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_hpt366.c linux-2.6.32.24/drivers/ata/pata_hpt366.c
--- linux-2.6.32.24/drivers/ata/pata_hpt366.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_hpt366.c	2010-09-04 15:54:51.000000000 -0400
@@ -282,7 +282,7 @@ static struct scsi_host_template hpt36x_
  *	Configuration for HPT366/68
  */
 
-static struct ata_port_operations hpt366_port_ops = {
+static const struct ata_port_operations hpt366_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= hpt36x_cable_detect,
 	.mode_filter	= hpt366_filter,
diff -urNp linux-2.6.32.24/drivers/ata/pata_hpt37x.c linux-2.6.32.24/drivers/ata/pata_hpt37x.c
--- linux-2.6.32.24/drivers/ata/pata_hpt37x.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_hpt37x.c	2010-09-04 15:54:51.000000000 -0400
@@ -576,7 +576,7 @@ static struct scsi_host_template hpt37x_
  *	Configuration for HPT370
  */
 
-static struct ata_port_operations hpt370_port_ops = {
+static const struct ata_port_operations hpt370_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.bmdma_stop	= hpt370_bmdma_stop,
@@ -591,7 +591,7 @@ static struct ata_port_operations hpt370
  *	Configuration for HPT370A. Close to 370 but less filters
  */
 
-static struct ata_port_operations hpt370a_port_ops = {
+static const struct ata_port_operations hpt370a_port_ops = {
 	.inherits	= &hpt370_port_ops,
 	.mode_filter	= hpt370a_filter,
 };
@@ -601,7 +601,7 @@ static struct ata_port_operations hpt370
  *	and DMA mode setting functionality.
  */
 
-static struct ata_port_operations hpt372_port_ops = {
+static const struct ata_port_operations hpt372_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.bmdma_stop	= hpt37x_bmdma_stop,
@@ -616,7 +616,7 @@ static struct ata_port_operations hpt372
  *	but we have a different cable detection procedure for function 1.
  */
 
-static struct ata_port_operations hpt374_fn1_port_ops = {
+static const struct ata_port_operations hpt374_fn1_port_ops = {
 	.inherits	= &hpt372_port_ops,
 	.prereset	= hpt374_fn1_pre_reset,
 };
diff -urNp linux-2.6.32.24/drivers/ata/pata_hpt3x2n.c linux-2.6.32.24/drivers/ata/pata_hpt3x2n.c
--- linux-2.6.32.24/drivers/ata/pata_hpt3x2n.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_hpt3x2n.c	2010-09-04 15:54:51.000000000 -0400
@@ -337,7 +337,7 @@ static struct scsi_host_template hpt3x2n
  *	Configuration for HPT3x2n.
  */
 
-static struct ata_port_operations hpt3x2n_port_ops = {
+static const struct ata_port_operations hpt3x2n_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.bmdma_stop	= hpt3x2n_bmdma_stop,
diff -urNp linux-2.6.32.24/drivers/ata/pata_hpt3x3.c linux-2.6.32.24/drivers/ata/pata_hpt3x3.c
--- linux-2.6.32.24/drivers/ata/pata_hpt3x3.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_hpt3x3.c	2010-09-04 15:54:51.000000000 -0400
@@ -141,7 +141,7 @@ static struct scsi_host_template hpt3x3_
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations hpt3x3_port_ops = {
+static const struct ata_port_operations hpt3x3_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	.set_piomode	= hpt3x3_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_icside.c linux-2.6.32.24/drivers/ata/pata_icside.c
--- linux-2.6.32.24/drivers/ata/pata_icside.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_icside.c	2010-09-04 15:54:51.000000000 -0400
@@ -319,7 +319,7 @@ static void pata_icside_postreset(struct
 	}
 }
 
-static struct ata_port_operations pata_icside_port_ops = {
+static const struct ata_port_operations pata_icside_port_ops = {
 	.inherits		= &ata_sff_port_ops,
 	/* no need to build any PRD tables for DMA */
 	.qc_prep		= ata_noop_qc_prep,
diff -urNp linux-2.6.32.24/drivers/ata/pata_isapnp.c linux-2.6.32.24/drivers/ata/pata_isapnp.c
--- linux-2.6.32.24/drivers/ata/pata_isapnp.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_isapnp.c	2010-09-04 15:54:51.000000000 -0400
@@ -23,12 +23,12 @@ static struct scsi_host_template isapnp_
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations isapnp_port_ops = {
+static const struct ata_port_operations isapnp_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.cable_detect	= ata_cable_40wire,
 };
 
-static struct ata_port_operations isapnp_noalt_port_ops = {
+static const struct ata_port_operations isapnp_noalt_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	/* No altstatus so we don't want to use the lost interrupt poll */
diff -urNp linux-2.6.32.24/drivers/ata/pata_it8213.c linux-2.6.32.24/drivers/ata/pata_it8213.c
--- linux-2.6.32.24/drivers/ata/pata_it8213.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_it8213.c	2010-09-04 15:54:51.000000000 -0400
@@ -234,7 +234,7 @@ static struct scsi_host_template it8213_
 };
 
 
-static struct ata_port_operations it8213_ops = {
+static const struct ata_port_operations it8213_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= it8213_cable_detect,
 	.set_piomode		= it8213_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_it821x.c linux-2.6.32.24/drivers/ata/pata_it821x.c
--- linux-2.6.32.24/drivers/ata/pata_it821x.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_it821x.c	2010-09-04 15:54:51.000000000 -0400
@@ -800,7 +800,7 @@ static struct scsi_host_template it821x_
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations it821x_smart_port_ops = {
+static const struct ata_port_operations it821x_smart_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.check_atapi_dma= it821x_check_atapi_dma,
@@ -814,7 +814,7 @@ static struct ata_port_operations it821x
 	.port_start	= it821x_port_start,
 };
 
-static struct ata_port_operations it821x_passthru_port_ops = {
+static const struct ata_port_operations it821x_passthru_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.check_atapi_dma= it821x_check_atapi_dma,
@@ -830,7 +830,7 @@ static struct ata_port_operations it821x
 	.port_start	= it821x_port_start,
 };
 
-static struct ata_port_operations it821x_rdc_port_ops = {
+static const struct ata_port_operations it821x_rdc_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 
 	.check_atapi_dma= it821x_check_atapi_dma,
diff -urNp linux-2.6.32.24/drivers/ata/pata_ixp4xx_cf.c linux-2.6.32.24/drivers/ata/pata_ixp4xx_cf.c
--- linux-2.6.32.24/drivers/ata/pata_ixp4xx_cf.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_ixp4xx_cf.c	2010-09-04 15:54:51.000000000 -0400
@@ -89,7 +89,7 @@ static struct scsi_host_template ixp4xx_
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations ixp4xx_port_ops = {
+static const struct ata_port_operations ixp4xx_port_ops = {
 	.inherits		= &ata_sff_port_ops,
 	.sff_data_xfer		= ixp4xx_mmio_data_xfer,
 	.cable_detect		= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pata_jmicron.c linux-2.6.32.24/drivers/ata/pata_jmicron.c
--- linux-2.6.32.24/drivers/ata/pata_jmicron.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_jmicron.c	2010-09-04 15:54:51.000000000 -0400
@@ -111,7 +111,7 @@ static struct scsi_host_template jmicron
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations jmicron_ops = {
+static const struct ata_port_operations jmicron_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.prereset		= jmicron_pre_reset,
 };
diff -urNp linux-2.6.32.24/drivers/ata/pata_legacy.c linux-2.6.32.24/drivers/ata/pata_legacy.c
--- linux-2.6.32.24/drivers/ata/pata_legacy.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_legacy.c	2010-09-04 15:54:51.000000000 -0400
@@ -106,7 +106,7 @@ struct legacy_probe {
 
 struct legacy_controller {
 	const char *name;
-	struct ata_port_operations *ops;
+	const struct ata_port_operations *ops;
 	unsigned int pio_mask;
 	unsigned int flags;
 	unsigned int pflags;
@@ -223,12 +223,12 @@ static const struct ata_port_operations 
  *	pio_mask as well.
  */
 
-static struct ata_port_operations simple_port_ops = {
+static const struct ata_port_operations simple_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.sff_data_xfer	= ata_sff_data_xfer_noirq,
 };
 
-static struct ata_port_operations legacy_port_ops = {
+static const struct ata_port_operations legacy_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.sff_data_xfer	= ata_sff_data_xfer_noirq,
 	.set_mode	= legacy_set_mode,
@@ -324,7 +324,7 @@ static unsigned int pdc_data_xfer_vlb(st
 	return buflen;
 }
 
-static struct ata_port_operations pdc20230_port_ops = {
+static const struct ata_port_operations pdc20230_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= pdc20230_set_piomode,
 	.sff_data_xfer	= pdc_data_xfer_vlb,
@@ -357,7 +357,7 @@ static void ht6560a_set_piomode(struct a
 	ioread8(ap->ioaddr.status_addr);
 }
 
-static struct ata_port_operations ht6560a_port_ops = {
+static const struct ata_port_operations ht6560a_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= ht6560a_set_piomode,
 };
@@ -400,7 +400,7 @@ static void ht6560b_set_piomode(struct a
 	ioread8(ap->ioaddr.status_addr);
 }
 
-static struct ata_port_operations ht6560b_port_ops = {
+static const struct ata_port_operations ht6560b_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= ht6560b_set_piomode,
 };
@@ -499,7 +499,7 @@ static void opti82c611a_set_piomode(stru
 }
 
 
-static struct ata_port_operations opti82c611a_port_ops = {
+static const struct ata_port_operations opti82c611a_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= opti82c611a_set_piomode,
 };
@@ -609,7 +609,7 @@ static unsigned int opti82c46x_qc_issue(
 	return ata_sff_qc_issue(qc);
 }
 
-static struct ata_port_operations opti82c46x_port_ops = {
+static const struct ata_port_operations opti82c46x_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= opti82c46x_set_piomode,
 	.qc_issue	= opti82c46x_qc_issue,
@@ -771,20 +771,20 @@ static int qdi_port(struct platform_devi
 	return 0;
 }
 
-static struct ata_port_operations qdi6500_port_ops = {
+static const struct ata_port_operations qdi6500_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= qdi6500_set_piomode,
 	.qc_issue	= qdi_qc_issue,
 	.sff_data_xfer	= vlb32_data_xfer,
 };
 
-static struct ata_port_operations qdi6580_port_ops = {
+static const struct ata_port_operations qdi6580_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= qdi6580_set_piomode,
 	.sff_data_xfer	= vlb32_data_xfer,
 };
 
-static struct ata_port_operations qdi6580dp_port_ops = {
+static const struct ata_port_operations qdi6580dp_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= qdi6580dp_set_piomode,
 	.sff_data_xfer	= vlb32_data_xfer,
@@ -855,7 +855,7 @@ static int winbond_port(struct platform_
 	return 0;
 }
 
-static struct ata_port_operations winbond_port_ops = {
+static const struct ata_port_operations winbond_port_ops = {
 	.inherits	= &legacy_base_port_ops,
 	.set_piomode	= winbond_set_piomode,
 	.sff_data_xfer	= vlb32_data_xfer,
@@ -978,7 +978,7 @@ static __init int legacy_init_one(struct
 	int pio_modes = controller->pio_mask;
 	unsigned long io = probe->port;
 	u32 mask = (1 << probe->slot);
-	struct ata_port_operations *ops = controller->ops;
+	const struct ata_port_operations *ops = controller->ops;
 	struct legacy_data *ld = &legacy_data[probe->slot];
 	struct ata_host *host = NULL;
 	struct ata_port *ap;
diff -urNp linux-2.6.32.24/drivers/ata/pata_marvell.c linux-2.6.32.24/drivers/ata/pata_marvell.c
--- linux-2.6.32.24/drivers/ata/pata_marvell.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_marvell.c	2010-09-04 15:54:51.000000000 -0400
@@ -100,7 +100,7 @@ static struct scsi_host_template marvell
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations marvell_ops = {
+static const struct ata_port_operations marvell_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.cable_detect		= marvell_cable_detect,
 	.prereset		= marvell_pre_reset,
diff -urNp linux-2.6.32.24/drivers/ata/pata_mpc52xx.c linux-2.6.32.24/drivers/ata/pata_mpc52xx.c
--- linux-2.6.32.24/drivers/ata/pata_mpc52xx.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_mpc52xx.c	2010-09-04 15:54:51.000000000 -0400
@@ -609,7 +609,7 @@ static struct scsi_host_template mpc52xx
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations mpc52xx_ata_port_ops = {
+static const struct ata_port_operations mpc52xx_ata_port_ops = {
 	.inherits		= &ata_sff_port_ops,
 	.sff_dev_select		= mpc52xx_ata_dev_select,
 	.set_piomode		= mpc52xx_ata_set_piomode,
diff -urNp linux-2.6.32.24/drivers/ata/pata_mpiix.c linux-2.6.32.24/drivers/ata/pata_mpiix.c
--- linux-2.6.32.24/drivers/ata/pata_mpiix.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_mpiix.c	2010-09-04 15:54:51.000000000 -0400
@@ -140,7 +140,7 @@ static struct scsi_host_template mpiix_s
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations mpiix_port_ops = {
+static const struct ata_port_operations mpiix_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.qc_issue	= mpiix_qc_issue,
 	.cable_detect	= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pata_netcell.c linux-2.6.32.24/drivers/ata/pata_netcell.c
--- linux-2.6.32.24/drivers/ata/pata_netcell.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_netcell.c	2010-09-04 15:54:51.000000000 -0400
@@ -34,7 +34,7 @@ static struct scsi_host_template netcell
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations netcell_ops = {
+static const struct ata_port_operations netcell_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.cable_detect	= ata_cable_80wire,
 	.read_id	= netcell_read_id,
diff -urNp linux-2.6.32.24/drivers/ata/pata_ninja32.c linux-2.6.32.24/drivers/ata/pata_ninja32.c
--- linux-2.6.32.24/drivers/ata/pata_ninja32.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_ninja32.c	2010-09-04 15:54:51.000000000 -0400
@@ -81,7 +81,7 @@ static struct scsi_host_template ninja32
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations ninja32_port_ops = {
+static const struct ata_port_operations ninja32_port_ops = {
 	.inherits	= &ata_bmdma_port_ops,
 	.sff_dev_select = ninja32_dev_select,
 	.cable_detect	= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pata_ns87410.c linux-2.6.32.24/drivers/ata/pata_ns87410.c
--- linux-2.6.32.24/drivers/ata/pata_ns87410.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_ns87410.c	2010-09-04 15:54:51.000000000 -0400
@@ -132,7 +132,7 @@ static struct scsi_host_template ns87410
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations ns87410_port_ops = {
+static const struct ata_port_operations ns87410_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.qc_issue	= ns87410_qc_issue,
 	.cable_detect	= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pata_ns87415.c linux-2.6.32.24/drivers/ata/pata_ns87415.c
--- linux-2.6.32.24/drivers/ata/pata_ns87415.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_ns87415.c	2010-09-04 15:54:51.000000000 -0400
@@ -299,7 +299,7 @@ static u8 ns87560_bmdma_status(struct at
 }
 #endif		/* 87560 SuperIO Support */
 
-static struct ata_port_operations ns87415_pata_ops = {
+static const struct ata_port_operations ns87415_pata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 
 	.check_atapi_dma	= ns87415_check_atapi_dma,
@@ -313,7 +313,7 @@ static struct ata_port_operations ns8741
 };
 
 #if defined(CONFIG_SUPERIO)
-static struct ata_port_operations ns87560_pata_ops = {
+static const struct ata_port_operations ns87560_pata_ops = {
 	.inherits		= &ns87415_pata_ops,
 	.sff_tf_read		= ns87560_tf_read,
 	.sff_check_status	= ns87560_check_status,
diff -urNp linux-2.6.32.24/drivers/ata/pata_octeon_cf.c linux-2.6.32.24/drivers/ata/pata_octeon_cf.c
--- linux-2.6.32.24/drivers/ata/pata_octeon_cf.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_octeon_cf.c	2010-09-04 15:54:51.000000000 -0400
@@ -801,6 +801,7 @@ static unsigned int octeon_cf_qc_issue(s
 	return 0;
 }
 
+/* cannot be const */
 static struct ata_port_operations octeon_cf_ops = {
 	.inherits		= &ata_sff_port_ops,
 	.check_atapi_dma	= octeon_cf_check_atapi_dma,
diff -urNp linux-2.6.32.24/drivers/ata/pata_oldpiix.c linux-2.6.32.24/drivers/ata/pata_oldpiix.c
--- linux-2.6.32.24/drivers/ata/pata_oldpiix.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_oldpiix.c	2010-09-04 15:54:51.000000000 -0400
@@ -208,7 +208,7 @@ static struct scsi_host_template oldpiix
 	ATA_BMDMA_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations oldpiix_pata_ops = {
+static const struct ata_port_operations oldpiix_pata_ops = {
 	.inherits		= &ata_bmdma_port_ops,
 	.qc_issue		= oldpiix_qc_issue,
 	.cable_detect		= ata_cable_40wire,
diff -urNp linux-2.6.32.24/drivers/ata/pata_opti.c linux-2.6.32.24/drivers/ata/pata_opti.c
--- linux-2.6.32.24/drivers/ata/pata_opti.c	2010-08-13 16:24:37.000000000 -0400
+++ linux-2.6.32.24/drivers/ata/pata_opti.c	2010-09-04 15:54:51.000000000 -0400
@@ -152,7 +152,7 @@ static struct scsi_host_template opti_sh
 	ATA_PIO_SHT(DRV_NAME),
 };
 
-static struct ata_port_operations opti_port_ops = {
+static const struct ata_port_operations opti_port_ops = {
 	.inherits	= &ata_sff_port_ops,
 	.cable_detect	= ata_cable_40wire,
 	.set_piomode	= opti_set_piomode,
